// Chad Nelson

#include "Board.h"

Board::Board() {
	loadLevel(1);
}

void Board::loadLevel(int l) {
	if (l < 0 || l > 5) return;

	level = l;
	walls.clear();
	pellets.clear();
	objects.clear();

	switch (l) {
		case 1:
			width = height = 21;
			
			// Create perimeter
			createWalls();

			// Create obsticle
			objects.push_back(new WallSegment(new Point2D(10,10)));

			// Create pellets
			for (int i = 3; i <= 17; i++) {
				if (i != 10)
					pellets.push_back(new Pellet(1, new Point2D(10,i)));
				pellets.push_back(new Pellet(1, new Point2D(12,i)));
				pellets.push_back(new Pellet(1, new Point2D(8,i)));
				if (i != 8 && i != 10 && i != 12)
					pellets.push_back(new Pellet(1, new Point2D(i, 10)));
			}
			pellets.push_back(new Pellet(20, new Point2D(2, 10)));
			pellets.push_back(new Pellet(20, new Point2D(18, 10)));

			break;
		case 2:
			width = 21;
			height = 23;

			// Create perimeter
			createWalls();

			// Create obsticles
			for (int i = 4; i < 17; i ++) {
				objects.push_back(new WallSegment(new Point2D(i, 4)));
				objects.push_back(new WallSegment(new Point2D(i, 18)));
			}
			objects.push_back(new WallSegment(new Point2D(9, 2)));
			objects.push_back(new WallSegment(new Point2D(9, 20)));
			objects.push_back(new WallSegment(new Point2D(11, 2)));
			objects.push_back(new WallSegment(new Point2D(11, 20)));

			// Create pellets
			for (int i = 6; i < 17; i ++) {
				if (i == 11) {
					pellets.push_back(new Pellet(50, new Point2D(10, 11)));
					continue;
				}

				pellets.push_back(new Pellet(1, new Point2D(5,i)));
				pellets.push_back(new Pellet(1, new Point2D(7,i)));
				pellets.push_back(new Pellet(1, new Point2D(13,i)));
				pellets.push_back(new Pellet(1, new Point2D(15,i)));
				pellets.push_back(new Pellet(5, new Point2D(10,i)));
			}
			// red pellets
			pellets.push_back(new Pellet(20, new Point2D(2, 2)));
			pellets.push_back(new Pellet(20, new Point2D(2, 11)));
			pellets.push_back(new Pellet(20, new Point2D(18, 2)));
			pellets.push_back(new Pellet(20, new Point2D(18, 11)));
			pellets.push_back(new Pellet(20, new Point2D(18, 20)));
			// grey pellets
			pellets.push_back(new Pellet(100, new Point2D(10, 2)));
			pellets.push_back(new Pellet(100, new Point2D(10, 20)));


			break;
		case 5:
			// Add additions to level 3

			// Walls
			for (int i = 15; i < 26; i ++) {
				objects.push_back(new WallSegment(new Point2D(4, i)));
				objects.push_back(new WallSegment(new Point2D(16, i)));
			}
			objects.push_back(new WallSegment(new Point2D(8, 16)));
			objects.push_back(new WallSegment(new Point2D(8, 17)));
			objects.push_back(new WallSegment(new Point2D(8, 20)));
			objects.push_back(new WallSegment(new Point2D(8, 23)));
			objects.push_back(new WallSegment(new Point2D(8, 24)));
			objects.push_back(new WallSegment(new Point2D(10, 14)));
			objects.push_back(new WallSegment(new Point2D(10, 15)));
			objects.push_back(new WallSegment(new Point2D(10, 18)));
			objects.push_back(new WallSegment(new Point2D(10, 19)));
			objects.push_back(new WallSegment(new Point2D(10, 21)));
			objects.push_back(new WallSegment(new Point2D(10, 22)));
			objects.push_back(new WallSegment(new Point2D(10, 25)));
			objects.push_back(new WallSegment(new Point2D(10, 26)));
			objects.push_back(new WallSegment(new Point2D(12, 16)));
			objects.push_back(new WallSegment(new Point2D(12, 17)));
			objects.push_back(new WallSegment(new Point2D(12, 20)));
			objects.push_back(new WallSegment(new Point2D(12, 23)));
			objects.push_back(new WallSegment(new Point2D(12, 24)));

			// Add pellets
			// red pellets
			pellets.push_back(new Pellet(20, new Point2D(2, 6)));
			pellets.push_back(new Pellet(20, new Point2D(2, 20)));
			pellets.push_back(new Pellet(20, new Point2D(2, 38)));
			pellets.push_back(new Pellet(20, new Point2D(18, 2)));
			pellets.push_back(new Pellet(20, new Point2D(18, 20)));
			pellets.push_back(new Pellet(20, new Point2D(18, 38)));
			// purple pellets
			pellets.push_back(new Pellet(50, new Point2D(5, 20)));
			pellets.push_back(new Pellet(50, new Point2D(15, 20)));
			// grey pellets
			pellets.push_back(new Pellet(100, new Point2D(8, 18)));
			pellets.push_back(new Pellet(100, new Point2D(8, 19)));
			pellets.push_back(new Pellet(100, new Point2D(8, 21)));
			pellets.push_back(new Pellet(100, new Point2D(8, 22)));
			pellets.push_back(new Pellet(100, new Point2D(12, 18)));
			pellets.push_back(new Pellet(100, new Point2D(12, 19)));
			pellets.push_back(new Pellet(100, new Point2D(12, 21)));
			pellets.push_back(new Pellet(100, new Point2D(12, 22)));
			// gold pellet
			pellets.push_back(new Pellet(300, new Point2D(10, 20)));
			// blue pellets
			for (int i = 15; i < 26; i++) {
				if (i == 20) continue;
				pellets.push_back(new Pellet(5, new Point2D(5, i)));
				pellets.push_back(new Pellet(5, new Point2D(15, i)));
			}
			// green pellets
			for (int i = 4; i < 17; i++) {
				pellets.push_back(new Pellet(5, new Point2D(i, 2)));
				pellets.push_back(new Pellet(5, new Point2D(i, 38)));
			}
			for (int i = 4; i < 17; i++) {
				if (i > 7)
				pellets.push_back(new Pellet(5, new Point2D(2, i)));
				pellets.push_back(new Pellet(5, new Point2D(18, i)));
				pellets.push_back(new Pellet(5, new Point2D(2, i + 18)));
				pellets.push_back(new Pellet(5, new Point2D(18, i + 18)));
			}

		case 3:
			width = 21;
			height = 41;

			// Create perimeter
			createWalls();

			// Create obsticles
			for (int i = 4; i < 17; i ++) {
				objects.push_back(new WallSegment(new Point2D(i, 4)));
				objects.push_back(new WallSegment(new Point2D(i, 13)));
				objects.push_back(new WallSegment(new Point2D(i, 27)));
				objects.push_back(new WallSegment(new Point2D(i, 36)));
			}
			for (int i = 5; i < 13; i ++)
				objects.push_back(new WallSegment(new Point2D(10, i)));
			for (int i = 28; i < 36; i ++)
				objects.push_back(new WallSegment(new Point2D(10, i)));
			
			// Create pellets
			for (int i = 5; i < 9; i ++) {
				pellets.push_back(new Pellet(1, new Point2D(i, 7)));
				pellets.push_back(new Pellet(1, new Point2D(i, 10)));
				pellets.push_back(new Pellet(1, new Point2D(i, 30)));
				pellets.push_back(new Pellet(1, new Point2D(i, 33)));
				pellets.push_back(new Pellet(1, new Point2D(i + 7, 7)));
				pellets.push_back(new Pellet(1, new Point2D(i + 7, 10)));
				pellets.push_back(new Pellet(1, new Point2D(i + 7, 30)));
				pellets.push_back(new Pellet(1, new Point2D(i + 7, 33)));
			}
			
			if (l == 3) {
				// red pellets
				pellets.push_back(new Pellet(20, new Point2D(2, 2)));
				pellets.push_back(new Pellet(20, new Point2D(2, 20)));
				pellets.push_back(new Pellet(20, new Point2D(18, 2)));
				pellets.push_back(new Pellet(20, new Point2D(18, 20)));
				pellets.push_back(new Pellet(20, new Point2D(18, 38)));
				// purple pellet
				pellets.push_back(new Pellet(50, new Point2D(10, 20)));
			}

			break;
		case 4:
			width = 31;
			height = 31;

			// Create perimeter
			createWalls();

			// Create objects
			for (int i = 6; i < 25; i ++) {
				objects.push_back(new WallSegment(new Point2D(6, i)));
				objects.push_back(new WallSegment(new Point2D(24, i)));
				if (i > 7)
				objects.push_back(new WallSegment(new Point2D(8, i)));
				if (i > 6 && i < 24)
				objects.push_back(new WallSegment(new Point2D(i, 6)));
				if (i > 8 && i < 24)
				objects.push_back(new WallSegment(new Point2D(i, 24)));
				if (i > 8 && i < 23) {
				objects.push_back(new WallSegment(new Point2D(i, 8)));
				objects.push_back(new WallSegment(new Point2D(22, i)));
				}
				if (i > 9 && i < 22) {
				objects.push_back(new WallSegment(new Point2D(i, 22)));
				objects.push_back(new WallSegment(new Point2D(10, i)));
				}
				if (i > 11 && i < 15) {
				objects.push_back(new WallSegment(new Point2D(12, i)));
				objects.push_back(new WallSegment(new Point2D(12, i + 6)));
				objects.push_back(new WallSegment(new Point2D(14, i)));
				objects.push_back(new WallSegment(new Point2D(18, i + 7)));
				objects.push_back(new WallSegment(new Point2D(i + 2, 20)));
				}
				if (i > 10 && i < 17) {
				objects.push_back(new WallSegment(new Point2D(i, 16)));
				objects.push_back(new WallSegment(new Point2D(18, i + 1)));
				objects.push_back(new WallSegment(new Point2D(i + 2, 18)));
				}
				if (i > 9 && i < 21)
				objects.push_back(new WallSegment(new Point2D(20, i)));
				if (i > 11 && i < 21)
				objects.push_back(new WallSegment(new Point2D(i, 10)));
				if (i > 10 && i < 15)
				objects.push_back(new WallSegment(new Point2D(16, i)));
			}


			// Create pellets
			for (int i = 2; i < 30; i+=2) {
				if (i < 24)
				pellets.push_back(new Pellet(1, new Point2D(i, 2)));
				pellets.push_back(new Pellet(1, new Point2D(i, 28)));
				if (i < 28 && i > 2) {
					pellets.push_back(new Pellet(1, new Point2D(2, i)));
					pellets.push_back(new Pellet(1, new Point2D(28, i)));
				}
			}
			pellets.push_back(new Pellet(20, new Point2D(15, 19)));
			pellets.push_back(new Pellet(50, new Point2D(13, 13)));

			break;
	}
}

void Board::draw() {	
	// Draw pellets
	list<Pellet *>::iterator it;
	for(it = pellets.begin(); it != pellets.end(); ++it) {
		Drawable *p = *it;
		p->draw();
	}

	// Draw walls
	for (unsigned int i = 0; i < walls.size(); i++) {
		walls[i]->draw();
	}
	// Draw objects
	for (unsigned int i = 0; i < objects.size(); i++) {
		objects[i]->draw();
	}
}

void Board::draw2D() {
	// Draw board
	int SIZE = 3;
	
	glBegin(GL_QUADS);
	glColor4f(1, 1, 1, 0.2f);
	for (int x = 0; x < width; x ++) {
		for (int y = 0; y < height; y ++) {
			if ((x + y) % 2 == 1) {
				glColor4f(1, 0.0, 1, 0.7f);
			} else {
				glColor4f(1, 1, 0.0, 0.95f);
			}
			glVertex2f(x * TILE_SIZE      , y       * TILE_SIZE);
			glVertex2f(x * TILE_SIZE      , (y + 1) * TILE_SIZE);
			glVertex2f((x + 1) * TILE_SIZE, (y + 1) * TILE_SIZE);
			glVertex2f((x + 1) * TILE_SIZE, y       * TILE_SIZE);
		}
	}

	// Draw pellets
	list<Pellet *>::iterator it;
	for(it = pellets.begin(); it != pellets.end(); ++it) {
		Pellet *p = *it;
		p->setColor();
		glVertex2f(p->position->x * TILE_SIZE      , p->position->y       * TILE_SIZE);
		glVertex2f(p->position->x * TILE_SIZE      , (p->position->y + 1) * TILE_SIZE);
		glVertex2f((p->position->x + 1) * TILE_SIZE, (p->position->y + 1) * TILE_SIZE);
		glVertex2f((p->position->x + 1) * TILE_SIZE, p->position->y       * TILE_SIZE);
	}

	// Draw walls
	for (unsigned int i = 0; i < walls.size(); i++) {
		walls[i];
	}
	// Draw objects
	for (unsigned int i = 0; i < objects.size(); i++) {
		objects[i];
	}

	glEnd();
}

void Board::drawOddSquares() {
	glBegin(GL_QUADS);
	glColor4f(1, 1, 1, 0.7f);
	for (int x = 0; x < width; x ++) {
		for (int y = 0; y < height; y ++) {
			if ((x + y) % 2 == 1) {
				glVertex3f(x * TILE_SIZE      , 0.0, y       * TILE_SIZE);
				glVertex3f(x * TILE_SIZE      , 0.0, (y + 1) * TILE_SIZE);
				glVertex3f((x + 1) * TILE_SIZE, 0.0, (y + 1) * TILE_SIZE);
				glVertex3f((x + 1) * TILE_SIZE, 0.0, y       * TILE_SIZE);
			}
		}
	}
	glEnd();
}

void Board::drawEvenSquares() {
	glBegin(GL_QUADS);
	glColor4f(1, 1, 1, 0.95f);
	for (int x = 0; x < width; x ++) {
		for (int y = 0; y < height; y ++) {
			if ((x + y) % 2 == 0) {
				glVertex3f(x * TILE_SIZE      , 0.0, y       * TILE_SIZE);
				glVertex3f(x * TILE_SIZE      , 0.0, (y + 1) * TILE_SIZE);
				glVertex3f((x + 1) * TILE_SIZE, 0.0, (y + 1) * TILE_SIZE);
				glVertex3f((x + 1) * TILE_SIZE, 0.0, y       * TILE_SIZE);
			}
		}
	}
	glEnd();
}





void Board::createWalls() {
	// Create boundary
	for (int i = -1; i <= height; i++) {
		walls.push_back(new WallSegment(new Point2D(-1, i)));
		walls.push_back(new WallSegment(new Point2D(width, i)));
	}
	for (int i = -1; i <= width; i++) {
		walls.push_back(new WallSegment(new Point2D(i, -1)));
		walls.push_back(new WallSegment(new Point2D(i, height)));
	}
}