// Chad Nelson

#include "Pellet.h"

Pellet::Pellet(int pts, Point2D *p) {
	points = pts;
	position = p;
	rotation = 0.0;
	if (pts == 20) {
		growth = -6;
	} else if (pts == 50) {
		growth = 51;
	} else {
		growth = 0;
	}
}

void Pellet::draw() {
	rotation += 0.1;
	glPushMatrix();
		setColor();
		glTranslatef((position->x + 0.5) * TILE_SIZE, TILE_SIZE / 2.0, (position->y + 0.5) * TILE_SIZE);
		glRotatef(rotation, 0.0, rotation, 0.0);
		glutSolidSphere(TILE_SIZE / 5.0, 8, 8);
	glPopMatrix();
}

void Pellet::setColor() {
	switch (points) {
		case 1:
			glColor3f(19.0/256.0, 151.0/256.0, 16.0/256.0);
			break;
		case 5:
			glColor3f(32.0/256.0, 71.0/256.0, 176.0/256.0);
			break;
		case 20:
			glColor3f(244.0/256.0, 0.0, 0.0);
			break;
		case 50:
			glColor3f(131.0/256.0, 93.0/256.0, 198.0/256.0);
			break;
		case 100:
			glColor3f(140.0/256.0, 140.0/256.0, 140.0/256.0);
			break;
		case 300:
			glColor3f(1.0, 240.0/256.0, 5.0/256.0);
			break;
	}
}