// Chad Nelson

#ifndef __Utilities__
#define __Utilities__

#include <stdlib.h>
#include "glut.h"
#include "time.h"
#include <iostream>
#include <string>
#include <vector>
#include <list>

using namespace std;

// Settings
#define FRAME_DELAY 25		// ms
#define TILE_SIZE	10.0	// size of tile
#define ZOOM_NEAR   1		// min zoom for camera follow
#define ZOOM_FAR	5		// max zoom for camera follow

// Menu Options
enum {QUIT, NEW_GAME, PAUSE, NOVICE, DIFFICULT, CAMERA_TOP, CAMERA_FOLLOW, CAMERA_CINE, TOGGLE_MINIMAP, INSANE, ZOOM_IN, ZOOM_OUT};

// Directional Choices
enum {TURN_NONE, TURN_LEFT, TURN_RIGHT};


// Utility Classes
class Drawable {
  public:
	virtual void draw() =0;
};

class Point2D {
  public:
	int x;
	int y;

	Point2D(int _x, int _y) {
		x = _x;
		y = _y;
	}
};

#endif